diff --git a/compiler/simplCore/FloatOut.lhs b/compiler/simplCore/FloatOut.lhs
index e0c39bf..109fa53 100644
--- a/compiler/simplCore/FloatOut.lhs
+++ b/compiler/simplCore/FloatOut.lhs
@@ -7,25 +7,19 @@
 
 \begin{code}
 {-# OPTIONS_GHC -fno-warn-orphans #-}
-{-# OPTIONS -fno-warn-tabs #-}
--- The above warning supression flag is a temporary kludge.
--- While working on this module you are encouraged to remove it and
--- detab the module (please do the detabbing in a separate patch). See
---     http://ghc.haskell.org/trac/ghc/wiki/Commentary/CodingStyle#TabsvsSpaces
--- for details
 
 module FloatOut ( floatOutwards ) where
 
 import CoreSyn
 import CoreUtils
 import MkCore
-import CoreArity	( etaExpand )
-import CoreMonad	( FloatOutSwitches(..) )
+import CoreArity        ( etaExpand )
+import CoreMonad        ( FloatOutSwitches(..) )
 
 import DynFlags
-import ErrUtils		( dumpIfSet_dyn )
-import Id		( Id, idArity, isBottomingId )
-import Var		( Var )
+import ErrUtils         ( dumpIfSet_dyn )
+import Id               ( Id, idArity, isBottomingId )
+import Var              ( Var )
 import SetLevels
 import UniqSupply       ( UniqSupply )
 import Bag
@@ -38,33 +32,33 @@ import qualified Data.IntMap as M
 #include "HsVersions.h"
 \end{code}
 
-	-----------------
-	Overall game plan
-	-----------------
+        -----------------
+        Overall game plan
+        -----------------
 
 The Big Main Idea is:
 
-  	To float out sub-expressions that can thereby get outside
-	a non-one-shot value lambda, and hence may be shared.
+        To float out sub-expressions that can thereby get outside
+        a non-one-shot value lambda, and hence may be shared.
 
 
 To achieve this we may need to do two thing:
 
    a) Let-bind the sub-expression:
 
-	f (g x)  ==>  let lvl = f (g x) in lvl
+        f (g x)  ==>  let lvl = f (g x) in lvl
 
       Now we can float the binding for 'lvl'.  
 
    b) More than that, we may need to abstract wrt a type variable
 
-	\x -> ... /\a -> let v = ...a... in ....
+        \x -> ... /\a -> let v = ...a... in ....
 
       Here the binding for v mentions 'a' but not 'x'.  So we
       abstract wrt 'a', to give this binding for 'v':
 
-	    vp = /\a -> ...a...
-	    v  = vp a
+            vp = /\a -> ...a...
+            v  = vp a
 
       Now the binding for vp can float out unimpeded.
       I can't remember why this case seemed important enough to
@@ -85,9 +79,9 @@ At the moment we never float a binding out to between two adjacent
 lambdas.  For example:
 
 @
-	\x y -> let t = x+x in ...
+        \x y -> let t = x+x in ...
 ===>
-	\x -> let t = x+x in \y -> ...
+        \x -> let t = x+x in \y -> ...
 @
 Reason: this is less efficient in the case where the original lambda
 is never partially applied.
@@ -97,49 +91,49 @@ But there's a case I've seen where this might not be true.  Consider:
 elEm2 x ys
   = elem' x ys
   where
-    elem' _ []	= False
-    elem' x (y:ys)	= x==y || elem' x ys
+    elem' _ []  = False
+    elem' x (y:ys)      = x==y || elem' x ys
 @
 It turns out that this generates a subexpression of the form
 @
-	\deq x ys -> let eq = eqFromEqDict deq in ...
+        \deq x ys -> let eq = eqFromEqDict deq in ...
 @
 vwhich might usefully be separated to
 @
-	\deq -> let eq = eqFromEqDict deq in \xy -> ...
+        \deq -> let eq = eqFromEqDict deq in \xy -> ...
 @
 Well, maybe.  We don't do this at the moment.
 
 
 %************************************************************************
-%*									*
+%*                                                                      *
 \subsection[floatOutwards]{@floatOutwards@: let-floating interface function}
-%*									*
+%*                                                                      *
 %************************************************************************
 
 \begin{code}
 floatOutwards :: FloatOutSwitches
-	      -> DynFlags
-	      -> UniqSupply 
-	      -> CoreProgram -> IO CoreProgram
+              -> DynFlags
+              -> UniqSupply 
+              -> CoreProgram -> IO CoreProgram
 
 floatOutwards float_sws dflags us pgm
   = do {
-	let { annotated_w_levels = setLevels float_sws pgm us ;
-	      (fss, binds_s')    = unzip (map floatTopBind annotated_w_levels)
-	    } ;
+        let { annotated_w_levels = setLevels float_sws pgm us ;
+              (fss, binds_s')    = unzip (map floatTopBind annotated_w_levels)
+            } ;
 
-	dumpIfSet_dyn dflags Opt_D_verbose_core2core "Levels added:"
-	          (vcat (map ppr annotated_w_levels));
+        dumpIfSet_dyn dflags Opt_D_verbose_core2core "Levels added:"
+                  (vcat (map ppr annotated_w_levels));
 
-	let { (tlets, ntlets, lams) = get_stats (sum_stats fss) };
+        let { (tlets, ntlets, lams) = get_stats (sum_stats fss) };
 
-	dumpIfSet_dyn dflags Opt_D_dump_simpl_stats "FloatOut stats:"
-		(hcat [	int tlets,  ptext (sLit " Lets floated to top level; "),
-			int ntlets, ptext (sLit " Lets floated elsewhere; from "),
-			int lams,   ptext (sLit " Lambda groups")]);
+        dumpIfSet_dyn dflags Opt_D_dump_simpl_stats "FloatOut stats:"
+                (hcat [ int tlets,  ptext (sLit " Lets floated to top level; "),
+                        int ntlets, ptext (sLit " Lets floated elsewhere; from "),
+                        int lams,   ptext (sLit " Lambda groups")]);
 
-	return (bagToList (unionManyBags binds_s'))
+        return (bagToList (unionManyBags binds_s'))
     }
 
 floatTopBind :: LevelledBind -> (FloatStats, Bag CoreBind)
@@ -152,9 +146,9 @@ floatTopBind bind
 \end{code}
 
 %************************************************************************
-%*									*
+%*                                                                      *
 \subsection[FloatOut-Bind]{Floating in a binding (the business end)}
-%*									*
+%*                                                                      *
 %************************************************************************
 
 \begin{code}
@@ -162,10 +156,10 @@ floatBind :: LevelledBind -> (FloatStats, FloatBinds, CoreBind)
 floatBind (NonRec (TB var _) rhs)
   = case (floatExpr rhs) of { (fs, rhs_floats, rhs') ->
 
-	-- A tiresome hack: 
-	-- see Note [Bottoming floats: eta expansion] in SetLevels
+        -- A tiresome hack: 
+        -- see Note [Bottoming floats: eta expansion] in SetLevels
     let rhs'' | isBottomingId var = etaExpand (idArity var) rhs'
-	      | otherwise         = rhs'
+              | otherwise         = rhs'
 
     in (fs, rhs_floats, NonRec var rhs'') }
 
@@ -177,7 +171,7 @@ floatBind (Rec pairs)
       | isTopLvl dest_lvl  -- See Note [floatBind for top level]
       = case (floatExpr rhs) of { (fs, rhs_floats, rhs') ->
         (fs, emptyFloats, addTopFloatPairs (flattenTopFloats rhs_floats) [(name, rhs')])}
-      | otherwise	  -- Note [Floating out of Rec rhss]
+      | otherwise         -- Note [Floating out of Rec rhss]
       = case (floatExpr rhs) of { (fs, rhs_floats, rhs') ->
         case (partitionByLevel dest_lvl rhs_floats) of { (rhs_floats', heres) ->
         case (splitRecFloats heres) of { (pairs, case_heres) ->
@@ -207,9 +201,9 @@ installUnderLambdas floats e
 ---------------
 floatList :: (a -> (FloatStats, FloatBinds, b)) -> [a] -> (FloatStats, FloatBinds, [b])
 floatList _ [] = (zeroStats, emptyFloats, [])
-floatList f (a:as) = case f a		 of { (fs_a,  binds_a,  b)  ->
-		     case floatList f as of { (fs_as, binds_as, bs) ->
-		     (fs_a `add_stats` fs_as, binds_a `plusFloats`  binds_as, b:bs) }}
+floatList f (a:as) = case f a            of { (fs_a,  binds_a,  b)  ->
+                     case floatList f as of { (fs_as, binds_as, bs) ->
+                     (fs_a `add_stats` fs_as, binds_a `plusFloats`  binds_as, b:bs) }}
 \end{code}
 
 Note [Floating out of Rec rhss]
@@ -247,28 +241,28 @@ but this case works just as well.
 %************************************************************************
 
 \subsection[FloatOut-Expr]{Floating in expressions}
-%*									*
+%*                                                                      *
 %************************************************************************
 
 \begin{code}
 floatBody :: Level
           -> LevelledExpr
-	  -> (FloatStats, FloatBinds, CoreExpr)
+          -> (FloatStats, FloatBinds, CoreExpr)
 
-floatBody lvl arg	-- Used rec rhss, and case-alternative rhss
+floatBody lvl arg       -- Used rec rhss, and case-alternative rhss
   = case (floatExpr arg) of { (fsa, floats, arg') ->
     case (partitionByLevel lvl floats) of { (floats', heres) ->
-	-- Dump bindings are bound here
+        -- Dump bindings are bound here
     (fsa, floats', install heres arg') }}
 
 -----------------
 floatExpr :: LevelledExpr
-	  -> (FloatStats, FloatBinds, CoreExpr)
+          -> (FloatStats, FloatBinds, CoreExpr)
 floatExpr (Var v)   = (zeroStats, emptyFloats, Var v)
 floatExpr (Type ty) = (zeroStats, emptyFloats, Type ty)
 floatExpr (Coercion co) = (zeroStats, emptyFloats, Coercion co)
 floatExpr (Lit lit) = (zeroStats, emptyFloats, Lit lit)
-	  
+          
 floatExpr (App e a)
   = case (floatExpr  e) of { (fse, floats_e, e') ->
     case (floatExpr  a) of { (fsa, floats_a, a') ->
@@ -276,10 +270,10 @@ floatExpr (App e a)
 
 floatExpr lam@(Lam (TB _ lam_spec) _)
   = let (bndrs_w_lvls, body) = collectBinders lam
-	bndrs		     = [b | TB b _ <- bndrs_w_lvls]
+        bndrs                = [b | TB b _ <- bndrs_w_lvls]
         bndr_lvl             = floatSpecLevel lam_spec
-	-- All the binders have the same level
-	-- See SetLevels.lvlLamBndrs
+        -- All the binders have the same level
+        -- See SetLevels.lvlLamBndrs
     in
     case (floatBody bndr_lvl body) of { (fs, floats, body') ->
     (add_to_stats fs floats, floats, mkLams bndrs body') }
@@ -288,8 +282,8 @@ floatExpr (Tick tickish expr)
   | tickishScoped tickish
   = case (floatExpr expr)    of { (fs, floating_defns, expr') ->
     let
-	-- Annotate bindings floated outwards past an scc expression
-	-- with the cc.  We mark that cc as "duplicated", though.
+        -- Annotate bindings floated outwards past an scc expression
+        -- with the cc.  We mark that cc as "duplicated", though.
         annotated_defns = wrapTick (mkNoTick tickish) floating_defns
     in
     (fs, annotated_defns, Tick tickish expr') }
@@ -306,22 +300,22 @@ floatExpr (Let bind body)
   = case bind_spec of
       FloatMe dest_lvl 
         -> case (floatBind bind) of { (fsb, bind_floats, bind') ->
-    	   case (floatExpr body) of { (fse, body_floats, body') ->
-    	   ( add_stats fsb fse 
-    	   , bind_floats `plusFloats` unitLetFloat dest_lvl bind' 
+           case (floatExpr body) of { (fse, body_floats, body') ->
+           ( add_stats fsb fse 
+           , bind_floats `plusFloats` unitLetFloat dest_lvl bind' 
                          `plusFloats` body_floats
-    	   , body') }}
+           , body') }}
 
       StayPut bind_lvl  -- See Note [Avoiding unnecessary floating]
         -> case (floatBind bind)          of { (fsb, bind_floats, bind') ->
-    	   case (floatBody bind_lvl body) of { (fse, body_floats, body') ->
-    	   ( add_stats fsb fse
-    	   , bind_floats `plusFloats` body_floats
-    	   , Let bind' body') }}
+           case (floatBody bind_lvl body) of { (fse, body_floats, body') ->
+           ( add_stats fsb fse
+           , bind_floats `plusFloats` body_floats
+           , Let bind' body') }}
   where
     bind_spec = case bind of 
-    	         NonRec (TB _ s) _     -> s
-		 Rec ((TB _ s, _) : _) -> s
+                 NonRec (TB _ s) _     -> s
+                 Rec ((TB _ s, _) : _) -> s
                  Rec []                -> panic "floatExpr:rec"
 
 floatExpr (Case scrut (TB case_bndr case_spec) ty alts)
@@ -329,24 +323,24 @@ floatExpr (Case scrut (TB case_bndr case_spec) ty alts)
       FloatMe dest_lvl  -- Case expression moves  
         | [(con@(DataAlt {}), bndrs, rhs)] <- alts
         -> case floatExpr scrut of { (fse, fde, scrut') ->
-    	   case floatExpr rhs   of { (fsb, fdb, rhs') ->
-    	   let 
-    	     float = unitCaseFloat dest_lvl scrut' 
+           case floatExpr rhs   of { (fsb, fdb, rhs') ->
+           let 
+             float = unitCaseFloat dest_lvl scrut' 
                           case_bndr con [b | TB b _ <- bndrs]
-    	   in
-    	   (add_stats fse fsb, fde `plusFloats` float `plusFloats` fdb, rhs') }}
+           in
+           (add_stats fse fsb, fde `plusFloats` float `plusFloats` fdb, rhs') }}
         | otherwise
         -> pprPanic "Floating multi-case" (ppr alts)
 
       StayPut bind_lvl  -- Case expression stays put
-    	-> case floatExpr scrut of { (fse, fde, scrut') ->
-    	   case floatList (float_alt bind_lvl) alts of { (fsa, fda, alts')  ->
-    	   (add_stats fse fsa, fda `plusFloats` fde, Case scrut' case_bndr ty alts')
-    	   }}
+        -> case floatExpr scrut of { (fse, fde, scrut') ->
+           case floatList (float_alt bind_lvl) alts of { (fsa, fda, alts')  ->
+           (add_stats fse fsa, fda `plusFloats` fde, Case scrut' case_bndr ty alts')
+           }}
   where
     float_alt bind_lvl (con, bs, rhs)
-	= case (floatBody bind_lvl rhs)	of { (fs, rhs_floats, rhs') ->
-	  (fs, rhs_floats, (con, [b | TB b _ <- bs], rhs')) }
+        = case (floatBody bind_lvl rhs) of { (fs, rhs_floats, rhs') ->
+          (fs, rhs_floats, (con, [b | TB b _ <- bs], rhs')) }
 \end{code}
 
 Note [Avoiding unnecessary floating]
@@ -373,25 +367,25 @@ We used instead to do the partitionByMajorLevel on the RHS of an '=',
 in floatRhs.  But that was quite tiresome.  We needed to test for
 values or trival rhss, because (in particular) we don't want to insert
 new bindings between the "=" and the "\".  E.g.
-	f = \x -> let <bind> in <body>
+        f = \x -> let <bind> in <body>
 We do not want
-	f = let <bind> in \x -> <body>
+        f = let <bind> in \x -> <body>
 (a) The simplifier will immediately float it further out, so we may
-	as well do so right now; in general, keeping rhss as manifest 
-	values is good
+        as well do so right now; in general, keeping rhss as manifest 
+        values is good
 (b) If a float-in pass follows immediately, it might add yet more
-	bindings just after the '='.  And some of them might (correctly)
-	be strict even though the 'let f' is lazy, because f, being a value,
-	gets its demand-info zapped by the simplifier.
+        bindings just after the '='.  And some of them might (correctly)
+        be strict even though the 'let f' is lazy, because f, being a value,
+        gets its demand-info zapped by the simplifier.
 And even all that turned out to be very fragile, and broke
 altogether when profiling got in the way.
 
 So now we do the partition right at the (Let..) itself.
 
 %************************************************************************
-%*									*
+%*                                                                      *
 \subsection{Utility bits for floating stats}
-%*									*
+%*                                                                      *
 %************************************************************************
 
 I didn't implement this with unboxed numbers.  I don't want to be too
@@ -399,9 +393,9 @@ strict in this stuff, as it is rarely turned on.  (WDP 95/09)
 
 \begin{code}
 data FloatStats
-  = FlS	Int  -- Number of top-floats * lambda groups they've been past
-	Int  -- Number of non-top-floats * lambda groups they've been past
-	Int  -- Number of lambda (groups) seen
+  = FlS Int  -- Number of top-floats * lambda groups they've been past
+        Int  -- Number of non-top-floats * lambda groups they've been past
+        Int  -- Number of lambda (groups) seen
 
 get_stats :: FloatStats -> (Int, Int, Int)
 get_stats (FlS a b c) = (a, b, c)
@@ -423,9 +417,9 @@ add_to_stats (FlS a b c) (FB tops others)
 
 
 %************************************************************************
-%*									*
+%*                                                                      *
 \subsection{Utility bits for floating}
-%*									*
+%*                                                                      *
 %************************************************************************
 
 Note [Representation of FloatBinds]
@@ -449,12 +443,12 @@ partitionByMajorLevel.
 
 
 \begin{code}
-type FloatLet = CoreBind	-- INVARIANT: a FloatLet is always lifted
-type MajorEnv = M.IntMap MinorEnv	  -- Keyed by major level
+type FloatLet = CoreBind        -- INVARIANT: a FloatLet is always lifted
+type MajorEnv = M.IntMap MinorEnv         -- Keyed by major level
 type MinorEnv = M.IntMap (Bag FloatBind)  -- Keyed by minor level
 
-data FloatBinds  = FB !(Bag FloatLet)	   	-- Destined for top level
-     		      !MajorEnv 		-- Levels other than top
+data FloatBinds  = FB !(Bag FloatLet)           -- Destined for top level
+                      !MajorEnv                 -- Levels other than top
      -- See Note [Representation of FloatBinds]
 
 instance Outputable FloatBind where
@@ -515,19 +509,19 @@ install defn_groups expr
   = foldrBag wrapFloat expr defn_groups
 
 partitionByLevel
-	:: Level		-- Partitioning level
-	-> FloatBinds   	-- Defns to be divided into 2 piles...
-	-> (FloatBinds,		-- Defns  with level strictly < partition level,
-	    Bag FloatBind)	-- The rest
+        :: Level                -- Partitioning level
+        -> FloatBinds           -- Defns to be divided into 2 piles...
+        -> (FloatBinds,         -- Defns  with level strictly < partition level,
+            Bag FloatBind)      -- The rest
 
 {-
--- 	 ---- partitionByMajorLevel ----
+--       ---- partitionByMajorLevel ----
 -- Float it if we escape a value lambda, 
 --     *or* if we get to the top level
 --     *or* if it's a case-float and its minor level is < current
 -- 
 -- If we can get to the top level, say "yes" anyway. This means that 
---	x = f e
+--      x = f e
 -- transforms to 
 --    lvl = e
 --    x = f lvl
